// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): John MacCuish (Los Alamos Nat. Lab.)

// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.

// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.

// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.

// Last File Update: 31-Jul-1996
// 


#include <stdlib.h>
#include <LINK/graph/UHyperGraph.h>
#include <LINK/basic/Set.h>
#include <LINK/basic/randomPermutation.h>
    
Graph* 
GenUHyperGraphKU(int n, int edges, int degree)
{
    UHyperGraph* graph = new UHyperGraph();

    graph->addVertices(n);
    Vertex** vertices = graph->vertexStart();

    // create array of vertices
    Vertex** degree_array = new Vertex*[n];

    int order = graph->order();
    int i,j;
    for (i=0; i < order; i++) 
       degree_array[i] = vertices[i];

    // Generate edges of graph, where each edge in the graph will have
    // "degree" number of vertices
    
    for (i=1; i <= edges; i++ ){
        Set<Vertex*> vertices;

	// permute the vertices and just take the first "degree" number of them
      	randomPermutation(degree_array,n);

        // create edges
        for(j=0; j<degree; j++)
	   vertices.insert(degree_array[j]);

	Edge* edge = graph->addEdge(vertices);
    }
    delete degree_array;
    return graph;
}
